/* PaperDragon
 *
 * Copyright (C) 2010 by Henry Kroll III, www.thenerdshow.com
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include <stdio.h>
#include <string.h>
#include <strings.h>
#define MAX_STR 4096
#ifdef __MINGW_H
#define strcasecmp stricmp
#endif
//{ struct c
typedef struct c
    char *text
    char *next
STR
//}
//{ strip  char *s
STR strip  char *s
    STR c
    c.text=s
    c.text+=strspn  s,"\" "
    /* remove trailing quotes and returns */
    c.next=c.text+strcspn  c.text,"\"\r\n"
    if  c.next-c.text < strlen(s)
        *(c.next++)='\0'
    /* returns struct pointer */
    return c
//}
//{ str_replaceall  char *str, char *find, char *rep
void str_replaceall  char *str, char *find, char *rep
    char *p,buffer[MAX_STR]
    int n
    while  (p=strstr(str,find))
        n=p-str
        strncpy  buffer,str,n
        sprintf  buffer+n,"%s%s",rep,p+strlen(find)
        strncpy  str,buffer,MAX_STR
    return
//}
//{ insertImage  char* fName
void insertImage  char* fName
    FILE *f
    STR c
    char *name,*caption,buf[MAX_STR],buf2[16],ext[5]
    int i,n,x,y
    /* sanity check */
    if  strlen(fName) < 4
        fprintf  stderr,"Err: Invalid image name"
        return
    /* strip quotes from name */
    strncpy  buf,fName,MAX_STR
    c=strip  buf
    name=c.text
    /* get extension */
    strncpy(ext,strrchr(name,'.')+1,3);ext[3]='\0'
    /* get caption */
    c=strip  c.next
    caption= c.text
    fprintf  stderr,"including '%s' '%s'\n",name,caption
    /* open file in binary mode */
    if  !(f=fopen (name, "rb"))
        fprintf  stderr,"Err: file '%s' not found\n", name
        return
    if  !strcasecmp(ext,"jpg")
        /* get width and height */
        /* find SOFO header (FFC0) */
        n=0       
        /* skip some bytes */
        n=fread  buf,1,4,f
        while  !feof(f)
            /* get length high byte, low byte */
            x=fgetc  f  ;x<<=8;x+=fgetc  f
            for  i=x;i--;
                n=fgetc  f
            if  n==0xC0||n==0xC2
                /* found SOFO header */
                break
        /* skip some bytes */
        for  i=3;i--;
            n=fgetc  f
        /* get x and y high byte, low byte */
        y=fgetc  f  ;y<<=8;y+=fgetc  f
        x=fgetc  f  ;x<<=8;x+=fgetc  f
        if  feof(f)
            fprintf  stderr,"Err: invalid jpg header.\n"
            fclose  f
            return
        rewind  f
        fprintf  stderr,"width: %i height: %i\n",x,y
        strcpy  ext, "jpeg"
    else if  !strcasecmp(ext,"png")
        /* get width and height */
        n=fread  buf2,1,16,f
        x=0;for  i=4;i--;
            x<<=8;x+=fgetc  f
        y=0;for  i=4;i--;
            y<<=8;y+=fgetc  f
        fprintf  stderr,"width: %i height: %i\n",x,y
        if  feof(f)
            fprintf  stderr,"Err: invalid png header.\n"
            fclose  f
            return
    else
        fprintf  stderr,"Err: only jpg and png are supported.\n"
        fclose  f
        return
    rewind  f
    /* scale image */
    n=x
    if  x<100
        x=100;y=(float)(100/n)*(float)y
    if  x>500
        x=320;y=(float)(320/n)*(float)y
    printf ("{\\trowd\\trqc\\trautofit1\\intbl\\cellx%i"
"{\\*\\shppict {\\pict \\%sblip"
"\\picwgoal%i\\pichgoal%i\n",x*15,ext,x*15,y*15)
    i=0
    while  (n=getc(f))!=EOF
        printf  "%02x",n
        i++
        if  i==64
            printf  "\n"
            i=0

    fclose(f)
    printf  "}}\n\\par\\ql\\i %s\\cell\\row}\\par\n",caption
    return
//}


//{ prolog  
void prolog  
    /* font list */
    puts  "{\\rtf1\\ansi\\deff0\n{\\fonttbl\n" 
    "{\\f0 Times New Roman;}\n" 
    "{\\f1 Arial;}\n" 
    "{\\f2 Courier New;}}\n"
    /* set margins to 1440 twips (1 inch) */
    puts  "\\deflang1033\\widowctrl\\margl1440\\margr1440\n"
    /* add a really basic color table, red blue and green */
    puts  "{\\colortbl;\n" 
          "\\red255\\green0\\blue0;\n" 
          "\\red0\\green0\\blue255;\n" 
          "\\red0\\green255\\blue0;}\n"
    return
//}
//{ main
int main  int argc, char** argv
    FILE *f=NULL
    char buf[MAX_STR],*t
    /* paragraph left */
    char *pl="{\\pard\\ql\\sl480 "
    /* paragraph centered */
    char *pc="{\\pard\\qc\\sl480 "
    /* paragraph end */
    char *pe="\\par}\n"
    /* paragraph references */
    char *pr="{\\pard\\ql\\sl480\\fi-720\\li720 "
    /* heading */
    char *head="{\\header\\qr "
    /* page */
    char *page="     \\chpgn}"
    int j,pgbrk,references
    if  argc==2
        /* open file in text mode (DOS \r\n conversion)*/
        f=fopen  argv[--argc],"r"
        buf[0]=0;
        fgets  buf,MAX_STR,f
        prolog()
        /* skip BOM */
        if  (t=strstr(buf,"Running Head: "))
            printf  "%s%s%s",head,t+14,page
            printf  "%s%s%s\n",pl,t,pe
            for  j=10;--j;
                puts  "{\\pard\\sl480\\par}"
            pgbrk=1
        else if  (t=strstr(buf,"Heading: "))
            printf  "%s%s%s\n",head,t+9,page
            for  j=10;--j;
                puts  "{\\pard\\sl480\\par}"
            pgbrk=1
        else
            pgbrk=0
            printf  "%s%s%s",(buf[0]==' ')?pc:pl,buf + strspn(buf, " "),pe
        references=0
        /* process document one line at a time */
        while  fgets(buf,MAX_STR,f)
            /* crude DOS linefeed conversion */
            str_replaceall(buf,"\r","")
            /* if blank line: remove it */
            if  strspn(buf," ") == strlen(buf) - 1
                if  pgbrk && pgbrk < 3
                    if  pgbrk == 1
                        pgbrk = 2
                    else
                        printf  "\\page\n"
                        pgbrk = 0
                continue
            /* if References: start reference page */
            if  strstr(buf,"  References\n") 
                ||strstr(buf,"References}\n")
                references=1
                /* center References heading on last page */
                printf  "\\page%s%s%s",pc,buf + strspn(buf, " "),pe
                continue
            /* support some very basic html markup */
            str_replaceall(buf,"<b>","{\\b ")
            str_replaceall(buf,"</b>","}")
            str_replaceall(buf,"<i>","{\\i ")
            str_replaceall(buf,"</i>","}")
            str_replaceall(buf,"<br/>","")
            str_replaceall(buf,"<br>","")
            str_replaceall(buf,"<tt>","")
            str_replaceall(buf,"</tt>","")
            str_replaceall(buf,"<p>","{")
            str_replaceall(buf,"</p>","\\par}\n")
            /* t is punctuation, if any */
            t=buf+strlen(buf)-2
            /* special commands start with a period */
            if  buf[0]=='.'
                if  !strncmp(buf,".image ",7)
                    insertImage(buf+7)
            else if  references
                printf  "%s%s%s",pr,buf + strspn(buf, " "),pe
            /* if no punctuation: heading, centered, left or bullet */
            else if  !strpbrk(t,",.:;!?\"")
                /* start heading on a new page? */
                if  pgbrk == 3
                    printf  "\\page\n"
                    pgbrk = 0
                else
                    printf  "%s%s%s",(buf[0]==' ')?pc:pl,buf + strspn(buf, " "),pe
                    /* fprintf  stderr,"'%s'\n",buf + strspn(buf, " ") */
                if  !strcmp(buf,"Abstract\n")
                    fprintf  stderr,"Abstract found!\n"
                    /* make next heading start on a new page */
                    pgbrk = 3
            /* all else: paragraph */
            else /* first indent 720 (.5 inch) */
                printf  "%s\\fi720 %s%s",pl,buf + strspn(buf, " "),pe
                /* fprintf  stderr,"%s%s%s",pl,buf + strspn(buf, " "),pe */
        puts  "}"
        fclose  f
    else
        puts  "Usage: pd paper.txt > paper.doc"
        return 1
    return 0
